function [cls,RAS,counts,icl]=GreedyICL(A,Ki,nbs,cli)
%% Perform Greddy ICL clustering
%% Input :
% A   : adjacency matrix (sparse matrix)
% Ki  : number of initial clusters
% nbs : number of starts
% cli : optional labels for initialisation
%% Output :
% cls : vector of class label
% RAS : matrix of intercluster connecivity (counts)
% counts : number of nodes per clusters
% icl : value of icl criterion
icl=-inf;
Ki=min(size(A,1),Ki);
if nargin ==4
    for s=1:nbs
        [clh,RA,count]=labelswitching(A,Ki,0,cli);
        [clh,RA,count]=hierarchical(sparse(RA),count,clh);
        icln=ICL(RA,count);
        if icln > icl
            icl=icln;
            RAS=RA;
            counts=count;
            cls=clh;
        end
    end
    
else
    for s=1:nbs
        [clh,RA,count]=labelswitching(A,Ki,0);
        [clh,RA,count]=hierarchical(sparse(RA),count,clh);
        icln=ICL(RA,count);
        if icln > icl
            icl=icln;
            RAS=RA;
            counts=count;
            cls=clh;
        end
    end
end

